﻿using GrapeCity.ActiveReports.Document;
using GrapeCity.ActiveReports;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Text;
using System.Windows.Forms;
using GrapeCity.ActiveReports.Export.Pdf.Section;
using System.Diagnostics;
using GrapeCity.Viewer.Common.Model;
using GrapeCity.ActiveReports.Document.Section;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Drawing.Text;

namespace v15_MICRFont
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            SectionReport1 rpt = new SectionReport1();
            rpt.FontResolver = DirectoryFontResolver.Instance;
            rpt.Run();
            viewer1.LoadDocument(rpt.Document);
            PdfExport exporter = new PdfExport();
            exporter.Export(rpt.Document, Application.StartupPath+"v16PDFExported.pdf");
            Process.Start(Application.StartupPath+"v16PDFExported.pdf");
        }
    }
    public sealed class DirectoryFontResolver : GrapeCity.ActiveReports.IFontResolver
    {
        static readonly GrapeCity.Documents.Text.FontCollection _fonts = new GrapeCity.Documents.Text.FontCollection();
        static DirectoryFontResolver()
        {
            var projectFolder = Path.GetFullPath(@"..\..\");
            _fonts.RegisterDirectory(projectFolder);
            _fonts.DefaultFont = _fonts.FindFamilyName("Arial");
        }
        public static GrapeCity.ActiveReports.IFontResolver Instance = new DirectoryFontResolver();
        private DirectoryFontResolver()
        { }

        GrapeCity.Documents.Text.FontCollection GrapeCity.ActiveReports.IFontResolver.GetFonts(string familyName, bool isBold, bool isItalic)
        {
            var fonts = new GrapeCity.Documents.Text.FontCollection();
            var font = _fonts.FindFamilyName(familyName, isBold, isItalic);
            if (font != null) fonts.Add(font);
            fonts.Add(_fonts.DefaultFont);
            return fonts;
        }
    }
}
